package ca.uwaterloo.cs.jgrok.env;

import org.xml.sax.Attributes;

public class TracingLoader extends DefaultLoader {

    public TracingLoader() {}
    
    public void startElement(String uri, String name, String qName, Attributes atts) {
        String evtName = null;
        String evtState = null;
        Tracing trc = env.getTracing();
        
        if (name.equalsIgnoreCase("Event")) {
            for(int i = 0; i < atts.getLength(); i++) {
                String localName = atts.getLocalName(i);
                
                if(localName.equalsIgnoreCase("Name"))
                    evtName = atts.getValue(i);
                else if(localName.equalsIgnoreCase("State"))
                    evtState = atts.getValue(i);
            }
            
            TracingEvent evt = new TracingEvent(evtName, evtState);
            trc.add(evt);
            if(trc.isEnabled()) {
                trc.out.println("\t" + evt);
            }
        }
        else if(name.equalsIgnoreCase("Tracing")) {
            for(int i = 0; i < atts.getLength(); i++) {
                String localName = atts.getLocalName(i);
                
                if(localName.equalsIgnoreCase("State"))
                    evtState = atts.getValue(i);
            }
            
            trc.setState(evtState);
            if (trc.isEnabled()) {
                trc.out.println("Loading " + name + " " + fileName + " ...");
            }
        }
    }
    
}
