package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.interp.*;

/**
 * <pre>
 *     int   int(int/float/string)
 *     float float(int/float/string)
 * </pre>
 */
public class Cast extends Function {
    
    public Cast() {
        name = "int";
        type = int.class;
        paramTypes = new Class[1];
        paramTypes[0] = String.class;
    }
        
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        Value val = vals[0];
        Class<?> valType = val.getType();
		Value	ret;

        
        if(name.equals("int")) {
            if(valType == int.class) {
                ret = new Value(val.intValue());
            } else if (valType == float.class) {
                ret = new Value((int)val.floatValue());
            } else if (valType == long.class) {
				ret = new Value((int)val.longValue());
            } else {
                try {
                    float f = Float.parseFloat(val.toString());
                    ret = new Value((int)f);
                } catch(Exception e) {
                    throw new InvocationException(e.getMessage());
                }
            }
//			System.out.println("int(" + val + ") returned " + ret);
            return ret;
		}         
        if (name.equals("float")) {
            if(valType == int.class) {
                ret = new Value((float)val.intValue());
            } else if (valType == float.class) {
                ret = new Value(val.floatValue());
            } else if (valType == long.class) {
				ret = new Value((float) val.longValue());
            } else {
                try {
                    float f = Float.parseFloat(val.toString());
                    ret = new Value(f);
                } catch(Exception e) {
                    throw new InvocationException(e.getMessage());
                }
            }
//          System.out.println("float(" + val + ") returned " + ret);
            return ret;
        }
        if (name.equals("long")) {
            if(valType == int.class) {
                ret = new Value((long)val.intValue());
            } else if (valType == float.class) {
                ret = new Value((long)val.floatValue());
            } else if (valType == long.class) {
				ret = new Value(val.longValue());
            } else {
                try {
                    long l = Long.parseLong(val.toString());
                    ret = new Value(l);
                } catch(Exception e) {
                    throw new InvocationException(e.getMessage());
                }
            }
//          System.out.println("long(" + val + ") returned " + ret);
            return ret;
        }
        throw new InvocationException("Unknown Cast function: " + name);
    }
}
