package ca.uwaterloo.cs.jgrok.lib;

import java.util.ArrayList;
import java.util.Enumeration;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.*;
import ca.uwaterloo.cs.jgrok.interp.*;

/**
 * int partition(EdgeSet graph, String sgPrefix)
 */
public class GraphPartition extends Function {
    
    public GraphPartition() {
        name = "partition";
        type = int.class;
        paramTypes = new Class[2];
        paramTypes[0] = EdgeSet.class;
        paramTypes[1] = String.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        String name;
        EdgeSet graph;
        EdgeSet subgraph;
        
        name = vals[1].toString() + "_";
        graph = (EdgeSet)vals[0].objectValue();
        
        Scope scp = env.peepScope();
        Enumeration<Variable> enm = scp.allVariables();
        ArrayList<Variable> list = new ArrayList<Variable>(5);
        
        Variable var;
        while(enm.hasMoreElements()) {
            var = enm.nextElement();
            if(var.getName().startsWith(name)) list.add(var);
        }
        
        for(int i = 0; i < list.size(); i++) {
            var = list.get(i);
            scp.removeVariable(var);
        }
        
        Partition p = new Partition();
        EdgeSet[] sgs = p.getPartitions(graph);
        
        for(int i = 0; i < sgs.length; i++) {
            subgraph = sgs[i];
            subgraph.setName(name + i);
            var = new Variable(scp, subgraph.getName(), new Value(subgraph));
            scp.addVariable(var);
        }
        
        return new Value(sgs.length);
    }
}
