package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.NodeSet;
import ca.uwaterloo.cs.jgrok.interp.Value;

/**
 * <pre>
 * Functions:
 *     string pick(set)
 *     set pick(set, int)
 * </pre>
 */
public class Pick extends Function {
    
    public Pick() {
        name = "pick";
        type = String.class;
        paramTypes = new Class[1];
        paramTypes[0] = NodeSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        NodeSet set = (NodeSet)vals[0].objectValue();
        if(vals.length == 1) {
            return new Value(set.pick());
        } else {
            int num = vals[1].intValue();
            return new Value(set.pick(num));
        }
    }
}
