package ca.uwaterloo.cs.jgrok.lib;

import java.io.*;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.interp.*;

/**
 * void parse(String scriptFile, String alias)
 */
public class ScriptParser extends Function {
    
    public ScriptParser() {
        name = "parse";
        type = void.class;
        paramTypes = new Class[2];
        paramTypes[0] = String.class;
        paramTypes[1] = String.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        String filePath  = vals[0].toString();
        String aliasName = vals[1].toString();
        
        File file;
        Interp interp;
        ScriptUnitNode unit;
        ScriptUnitNode master;
        master = env.traceScriptUnit();
        
        try {
            try {
                file = new File(filePath);
                interp = Interp.reinit(file);
            } catch(FileNotFoundException e) {
                if(filePath.charAt(0) == '~') {
                    file = new File(System.getProperty("user.home"), filePath.substring(1));
                } else {
                    file = new File(master.getFileParent(), filePath);
                }
                interp = Interp.reinit(file);
            }
            
            unit = interp.parse();
            unit.setAliasName(aliasName);
            master.addSourceUnit(unit);
        } catch(FileNotFoundException e) {
            throw new InvocationException("no such a file: " + filePath);
        }
        
        return Value.VOID;
    }
}
