package ca.uwaterloo.cs.jgrok.lib.math;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.interp.*;
import ca.uwaterloo.cs.jgrok.lib.Function;
import ca.uwaterloo.cs.jgrok.lib.InvocationException;

/**
 * <pre>
 *     float ln(int);
 *     float ln(float);
 *
 *     float log(int, int);
 *     float log(int, float);
 * </pre>
 */
public class Logarithm extends Function {
    
    public Logarithm(String functionName) {
        this.name = functionName;
        type = float.class;
        paramTypes = new Class[2];
        paramTypes[0] = int.class;
        paramTypes[1] = float.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        
        try {
            if(vals.length == 2) {
                int base = vals[0].intValue();
                float value = vals[1].floatValue();
                return new Value( (float)(Math.log((double)value)/Math.log((double)base)));
            } else {
                float value = vals[0].floatValue();
                return new Value((float)(Math.log((double)value)));
            }
        } catch(Exception e) {
            throw new InvocationException(e.getMessage());
        }
    }
}
