package ca.uwaterloo.cs.jgrok.lib.time;

import java.util.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.interp.*;
import ca.uwaterloo.cs.jgrok.lib.Function;
import ca.uwaterloo.cs.jgrok.lib.InvocationException;

/**
 * <pre>
 *     string datetimeas(long, [pattern]);
 * </pre>
 */
public class DateTimeAs extends Function {
    
    static Date				m_date        = new Date();
    static String			m_lastPattern = null;
    static SimpleDateFormat	m_lastFormat  = null;
  
    public DateTimeAs() {
        name = "datetimeas";
        type = String.class;
        paramTypes = new Class[2];
        paramTypes[0] = int.class;		// Millisecs
        paramTypes[1] = String.class;	// Pattern
	}
       
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        
        try {
            String				pattern = null;
            SimpleDateFormat	dateFormat;
            long				millsecs;
                
            millsecs = vals[0].longValue();
            switch(vals.length) {
            case 2:
				pattern = vals[1].toString();
			}
			
			if (pattern == m_lastPattern) {
				dateFormat = m_lastFormat;
				if (dateFormat == null) {
					m_lastFormat = dateFormat = new SimpleDateFormat();
				}
			} else {
				if (pattern == null) {
					dateFormat = new SimpleDateFormat();
				} else {
					dateFormat = new SimpleDateFormat(pattern);
				}
				m_lastPattern = pattern;
				m_lastFormat  = dateFormat;
			}
          	m_date.setTime(millsecs);
            return new Value(dateFormat.format(m_date));
        } catch(Exception e) {
            throw new InvocationException(e.getMessage());
        }
    }
}
